--[[
=============================================
CoLUAmns 0.1 by mikehaggar99(at)gmail(dot)com
=============================================
]]

dofile("./font.lua")
dofile("./browser.lua")

background = Image.load("bg.png")
overlay = Image.load("overlay.png")
jewels = Image.load("jewels.png")
action = Image.createEmpty(480, 272)

soundfile = Sound.load("hit.wav")
soundfile2 = Sound.load("dissolve.wav")
soundfile3 = Sound.load("gameover.wav")
soundfile4 = Sound.load("turn.wav")

whiteColor = Color.new(255,255,255)

overlay:print(322,96,"Level:",whiteColor)
overlay:print(322,116,"Jewels:",whiteColor)
overlay:print(322,136,"Score:",whiteColor)
overlay:print(322,156,"High:",whiteColor)

buttonPush = {0,0}
padPush = {0,0}
next = {1,1,1}
current = {1,1,1}
currentTemp=0
positionx = 3
positiony = 2
exit2=false
delay=0
level=0
jewel=0
high=0
score=0

tileIndex = {{x=0,y=0},{x=0,y=1},{x=0,y=2},{x=0,y=3},{x=0,y=4},{x=0,y=5},{x=0,y=6}}

board = {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}}


function drawJewelTile(index, x, y)
	action:blit(180+20*x, 20*y-40, jewels, 20*tileIndex[index].x, 20*tileIndex[index].y, 20, 20)
end


function drawSet(index, x, y)
	drawJewelTile(index[3], x, y-2)
	drawJewelTile(index[2], x, y-1)
	drawJewelTile(index[1], x, y)
end


function drawBoard()
	for i=1,6 do
		for j=3,15 do
			if board[i][j]>0 and board[i][j]<7 then
				drawJewelTile(board[i][j], i-1, j-1)
			elseif board[i][j]>6 then
				drawJewelTile(7, i-1, j-1)
			end
		end
	end
end


function drawScreen()
	screen:clear()
	action:clear()
	drawBoard()
	drawSet(next, 7, 5)

	screen:blit(0, 0, background)
	screen:blit(0, 0, overlay)
	screen:blit(0, 0, action)
	infoPrint()

	screen.waitVblankStart()
	screen.flip()
	screen.waitVblankStart(5)
end


function checkPosition(x,y)
	if positionx+x>5 then
		return false
	end

	if positionx+x<0 then
		return false
	end

	if math.floor(positiony+y)>14 then
		return false
	end

	if x==0 then
		if board[positionx+x+1][math.floor(positiony+y)+1]>0 then
			return false
		end
	elseif y==0 then
		if board[positionx+x+1][math.ceil(positiony+y)+1]>0 then
			return false
		end
	end

	return true
end


function removeLines()
	returnvalue=0
	temporary=0
	for i=1,6 do
		for j=3,15 do
			if board[i][j]>0 then
				if i<5 then
					if board[i+1][j]>0 and board[i+2][j]>0 and math.mod(board[i][j],6)==math.mod(board[i+1][j],6) and math.mod(board[i][j],6)==math.mod(board[i+2][j],6) then
						board[i][j]=board[i][j]+6
						board[i+1][j]=board[i+1][j]+6
						board[i+2][j]=board[i+2][j]+6
						temporary=1
					end
				end
				if j<14 then
					if board[i][j+1]>0 and board[i][j+2]>0 and math.mod(board[i][j],6)==math.mod(board[i][j+1],6) and math.mod(board[i][j],6)==math.mod(board[i][j+2],6) then
						board[i][j]=board[i][j]+6
						board[i][j+1]=board[i][j+1]+6
						board[i][j+2]=board[i][j+2]+6
						temporary=1
					end
				end
			end
			if i<5 and j<14 then
				if board[i][j]>0 and board[i+1][j+1]>0 and board[i+2][j+2]>0 and math.mod(board[i][j],6)==math.mod(board[i+1][j+1],6) and math.mod(board[i][j],6)==math.mod(board[i+2][j+2],6) then
					board[i][j]=board[i][j]+6
					board[i+1][j+1]=board[i+1][j+1]+6
					board[i+2][j+2]=board[i+2][j+2]+6
					temporary=1
				end
				if board[i][j+2]>0 and board[i+1][j+1]>0 and board[i+2][j]>0 and math.mod(board[i][j+2],6)==math.mod(board[i+1][j+1],6) and math.mod(board[i][j+2],6)==math.mod(board[i+2][j],6) then
					board[i][j+2]=board[i][j+2]+6
					board[i+1][j+1]=board[i+1][j+1]+6
					board[i+2][j]=board[i+2][j]+6
					temporary=1
				end
			end
		end
	end

	if temporary==1 then
		drawScreen()
		screen.waitVblankStart(5)
		soundfile2:play()

		for i=1,6 do
			for j=3,15 do
				if board[i][j]>6 then
					board[i][j]=0
					score=score+10
					jewel=jewel+1
				end
			end
		end

		drawScreen()

		alldone=false
		while alldone==false do
			alldone=true
			for i=1,6 do
				j=15
				while j>1 do
					if board[i][j]==0 and board[i][j-1]>0 then
						board[i][j]=board[i][j-1]
						board[i][j-1]=0
						returnvalue=1
						alldone=false
					end
					j=j-1
				end
			end
			drawScreen()
		end

		if returnvalue==1 then
			removeLines()
		end
	end
end


function checkEnd()
	for i=1,6 do
		if board[i][1]>0 or board[i][2]>0 then
			return true
		end
	end

	if board[4][3]>0 then
		return true
	end
	return false
end


function infoPrint()
	if score>9999999999 then
		score=9999999999
	end

	if score>high then
		high=score
	end

	if math.floor(jewel/50)<10 and math.floor(jewel/50)>level then
		level = math.floor(jewel/50)
	end

	screen:print(322,106,string.format("%10d", level),whiteColor)
	screen:print(322,126,string.format("%10d", jewel),whiteColor)
	screen:print(322,146,string.format("%10d", score),whiteColor)
	screen:print(322,166,string.format("%10d", high),whiteColor)
end


function gameOver()
	stopped=0

	screen:clear()
	screen:blit(0, 0, background)
	screen:blit(0, 0, overlay)
	screen:blit(0, 0, action)
	infoPrint()
	printEdit(212, 120, "GAME", whiteColor, screen, 0, 2)
	printEdit(212, 136, "OVER", whiteColor, screen, 0, 2)
	if Music.playing() then
		Music.pause()
		stopped=1
	end
	screen.waitVblankStart()
	screen.flip()
	gostart=false
	soundfile3:play()
	repeat
		pad = Controls.read()
		if pad:start() then 
			gostart=true
		end
	until gostart==true
	board = {{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}}
	next[1]=math.random(1,6)
	next[2]=math.random(1,6)
	next[3]=math.random(1,6)
	level=0
	jewel=0
	score=0
	screen.waitVblankStart(30)
	if stopped==1 then
		Music.resume()
	end
end


function control()
	pad = Controls.read()
	if pad:select() then
		if Music.playing() then
			Music.stop()
		end
		exit2=true
		screen.waitVblankStart(10)
	end

	if pad:start() then
		stopped=0
		gostart=false
		screen:clear()
		action:clear()
		screen:blit(0, 0, background)
		screen:blit(0, 0, overlay)
		infoPrint()
		printEdit(204, 128, "PAUSE", whiteColor, screen, 0, 2)
		if Music.playing() then
			Music.pause()
			stopped=1
		end
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart(10)
		repeat
			pad = Controls.read()
			if pad:start() then 
				gostart=true
			end
		until gostart==true
		screen.waitVblankStart(10)
		if stopped==1 then
			Music.resume()
		end
	end

	if pad:hold() then
		stopped=0
		gostart=false
		screen:clear()
		action:clear()
		screen:blit(0, 0, background)
		screen:blit(0, 0, overlay)
		infoPrint()
		printEdit(212, 128, "HOLD", whiteColor, screen, 0, 2)
		if Music.playing() then
			Music.pause()
			stopped=1
		end
		screen.waitVblankStart()
		screen.flip()
		repeat
			pad = Controls.read()
			if not pad:hold() then
				gostart=true
			end
		until gostart==true
		screen.waitVblankStart(10)
		if stopped==1 then
			Music.resume()
		end
	end

	if pad:triangle() then
		screen:save("screenshot.tga")
	end

	if pad:left() and checkPosition(-1,0) then
		if padPush[1]==0 then
			positionx=positionx-1
		end
		padPush[1]=math.mod(padPush[1]+1,2)
		padPush[2]=0
	elseif pad:right() and checkPosition(1,0) then
		if padPush[2]==0 then
			positionx=positionx+1
		end
		padPush[2]=math.mod(padPush[2]+1,2)
		padPush[1]=0
	else
		padPush={0,0}
	end

	if pad:down() and checkPosition(0,1) then
		positiony=positiony+0.5
		score=score+1
	end

	if pad:circle() then
		if buttonPush[1]==0 then
			currentTemp=current[1]
			current[1]=current[2]
			current[2]=current[3]
			current[3]=currentTemp
			soundfile4:play()
		end
		buttonPush[1]=math.mod(buttonPush[1]+1,4)
		buttonPush[2]=0
	elseif pad:cross() then
		if buttonPush[2]==0 then
			currentTemp=current[3]
			current[3]=current[2]
			current[2]=current[1]
			current[1]=currentTemp
			soundfile4:play()
		end
		buttonPush[2]=math.mod(buttonPush[2]+1,4)
		buttonPush[1]=0
	else
		buttonPush={0,0}
	end

	if pad:l() then
		if Music.playing() then
			Music.stop()
		end
		fileid,filepath = browser({".mod",".s3m",".xm",".it"},"ms0:/psp/music",1,0,1,0)
		if fileid==false then
		else
			olddir=System.currentDirectory()
			System.currentDirectory(filepath)
			Music.playFile(fileid, true)
			System.currentDirectory(olddir)
		end
		screen.waitVblankStart(10)
	elseif pad:r() then
		stopped=0
		if Music.playing() then
			Music.pause()
			stopped=1
		end
		filename,directory = browser({".png"},System.currentDirectory(),1,-1,1,0)
		if filename==false then
			background = Image.load("bg.png")
		else
			background = Image.load(string.format("%s%s",directory,filename))
		end
		screen.waitVblankStart(10)
		if stopped==1 then
			Music.resume()
		end
	end
end


screen:clear()
printEdit(10, 20, "C", Color.new(255,128,0), screen, 0, 12)
printEdit(80, 20, "O", Color.new(255,128,0), screen, 0, 10)
printEdit(140, 20, "L", Color.new(255,128,0), screen, 0, 8)
printEdit(190, 20, "U", Color.new(255,128,0), screen, 0, 6)
printEdit(230, 20, "A", Color.new(255,128,0), screen, 0, 6)
printEdit(270, 20, "M", Color.new(255,128,0), screen, 0, 8)
printEdit(320, 20, "N", Color.new(255,128,0), screen, 0, 10)
printEdit(380, 20, "S", Color.new(255,128,0), screen, 0, 12)
printEdit(440, 100, "v0.1", whiteColor, screen, 0, 1)
printEdit(11, 120, "mikehaggar99(at)gmail(dot)com", whiteColor, screen, 0, 2)
printEdit(28, 209, "PRESS START", whiteColor, screen, 0, 5)
screen.waitVblankStart()
screen.flip()

while exit2==false do
	pad = Controls.read()
	if pad:start() then
		exit2=true
		screen.waitVblankStart(10)
	end
	if pad:triangle() then
		screen:save("screenshot.tga")
	end
end

exit2=false
math.randomseed(os.time())
current[1]=math.random(1,6)
current[2]=math.random(1,6)
current[3]=math.random(1,6)
next[1]=math.random(1,6)
next[2]=math.random(1,6)
next[3]=math.random(1,6)

while exit2==false do
	control()

	screen:clear()
	action:clear()

	drawBoard()
	drawSet(current, positionx, positiony)
	drawSet(next, 7, 5)
	screen:blit(0, 0, background)
	screen:blit(0, 0, overlay)
	screen:blit(0, 0, action)
	infoPrint()
	screen.waitVblankStart()
	screen.flip()

	if delay>10-level and checkPosition(0,1) and checkPosition(0,0) then
		positiony=positiony+0.5
		delay=-1
	elseif checkPosition(0,1) and checkPosition(0,0) then
	elseif delay>10-level or delay>6 then
		if positiony<0 then
			gameOver()
		else
			soundfile:play()
			board[positionx+1][positiony+1]=current[1]
			board[positionx+1][positiony]=current[2]
			board[positionx+1][positiony-1]=current[3]
			removeLines()
		end
		if checkEnd() then
			gameOver()
		end
		current[1]=next[1]
		current[2]=next[2]
		current[3]=next[3]
		next[1]=math.random(1,6)
		next[2]=math.random(1,6)
		next[3]=math.random(1,6)
		positiony=2
		positionx=3
		delay=-1
	end

	delay=delay+1
end
